



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>HDU 4643 GSM 简单计算几何</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">HDU 4643 GSM 简单计算几何</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-02 20:07:05 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>今天比赛的时候略坑， admin告诉我询问Q的个数不超过n^2, 赛后敲了个 O(Q*m^3)的复杂度，但这个复杂度常数比较低，可能在除以个小常数， 300ms过了，真心无语，数据应该水了吧，比赛的时候已经想到了，但怕超时没敢敲。</p>
<p>这次的题解好坑， 说什么是要用什么图做，真心蛋疼，搞得这么高端干什么，看懂了它的思路，代码写起来不好写，至少我是这样的。</p>
<p>我的做法：</p>
<p>先预处理出每两个station之间的中垂线。</p>
<p>对于每个询问，判断每条中垂线与询问的两城市之间的连线是否相交(设交点P)。</p>
<p>当然相交也不一定说明交点是 信号改变的点，因为2个station的点可能不是距离P最近的点，我们要判其它station与P点的距离是否小于这两个station的距离，</p>
<p>如果是那么这条中垂线就是无效的，其它都是有效的，ans++。</p>
<p>代码：</p>
<pre class="prettyprint linenums">#include &lt;cstdio&gt;<br />
#include &lt;cmath&gt;<br />
const double eps = 1e-8;<br />
inline int dcmp(double x) {<br />
    if(fabs(x) &lt; eps) return 0;<br />
    return x &gt; eps ? 1 : -1;<br />
}<br />
struct point {<br />
    double x, y;<br />
    point(double x, double y) :<br />
            x(x), y(y) {<br />
    }<br />
    point() {<br />
    }<br />
    point operator+(const point &amp;t) const {<br />
        return point(x + t.x, y + t.y);<br />
    }<br />
    point operator-(const point &amp;t) const {<br />
        return point(x - t.x, y - t.y);<br />
    }<br />
    point operator*(const double &amp;t) const {<br />
            return point(x*t, y*t);<br />
    }<br />
    inline void in() {<br />
        scanf("%lf%lf", &amp;x, &amp;y);<br />
    }<br />
} sta[55], city[55], tt, tp;<br />
struct line {<br />
    point a, b;<br />
    line(point a, point b) :<br />
            a(a), b(b) {<br />
    }<br />
    line() {<br />
    }<br />
} l[50][50];<br />
int n, m, k;<br />
inline line getMidLine(const point &amp;a, const point &amp;b) {<br />
    point mid = (a + b) *0.5;<br />
    point tp = b-a;<br />
    return line(mid, mid+point(-tp.y, tp.x));<br />
}

inline double cross(const point &amp;a, const point &amp;b) {<br />
    return a.x*b.y-a.y*b.x;<br />
}<br />
inline point intersect(const point &amp;a, const point &amp;b, const point &amp;l, const point &amp;r) {<br />
    point ret = a;<br />
    double t = ((a.x - l.x) * (l.y - r.y) - (a.y - l.y) * (l.x - r.x))<br />
            / ((a.x - b.x) * (l.y - r.y) - (a.y - b.y) * (l.x - r.x));<br />
    ret.x += (b.x - a.x) * t;<br />
    ret.y += (b.y - a.y) * t;<br />
    return ret;<br />
}<br />
inline bool dotOnSeg(const point &amp;p, const point &amp;l, const point &amp;r) {  //判点在线段上<br />
    return (p.x-l.x)*(p.x-r.x) &lt; eps<br />
    &amp;&amp; (p.y-l.y)*(p.y-r.y) &lt; eps;<br />
}<br />
inline double dis(const point &amp;a, const point &amp;b) {<br />
    return sqrt( (a.x-b.x)*(a.x-b.x) + (a.y-b.y)*(a.y-b.y));<br />
}<br />
inline bool judge(const point &amp;p, int &amp;a) {<br />
    double d = dis(p, sta[a]);<br />
    int i;<br />
    for(i = 0; i &lt; m; i++) if(i != a)<br />
        if(d &gt; dis(p, sta[i])+eps) return 0;<br />
    return 1;<br />
}<br />
int a, b, ans;<br />
int main() {<br />
    int i, j;<br />
    while (~scanf("%d%d", &amp;n, &amp;m)) {<br />
        for (i = 0; i &lt; n; i++) city[i].in();<br />
        for (i = 0; i &lt; m; i++) sta[i].in();<br />
        for (i = 0; i &lt; m; i++)<br />
            for (j = i + 1; j &lt; m; j++)<br />
                l[i][j] = getMidLine(sta[i], sta[j]);

        scanf("%d", &amp;k);<br />
        while(k--) {<br />
            ans = 0;<br />
            scanf("%d%d", &amp;a, &amp;b);<br />
            a--; b--;<br />
            tt = city[a]-city[b];<br />
            for(i = 0; i &lt; m; i++)<br />
                for(j = i+1; j &lt; m; j++) {<br />
                    if(!dcmp(cross(tt, l[i][j].a-l[i][j].b))) continue;<br />
                    tp = intersect(city[a], city[b], l[i][j].a, l[i][j].b);<br />
                    if(dotOnSeg(tp, city[a], city[b]))<br />
                        ans += judge(tp, i);<br />
                }<br />
            printf("%d\n", ans);<br />
        }<br />
    }<br />
    return 0;<br />
}
</pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4qnvwpg8.html">JAVA集合</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwlk1l9.html">jQuery：详解jQuery中的事件（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvzw5o9.html">Maximo 7&period;5 集成方式 去掉主菜单</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o3p149.html">jQuery之Nestable</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd2xrdq.html">WordPress主题制作教程7：引用其他php的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m07gkq.html">发现可高速缓存的 SSL 页面</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k17jm39.html">ECMAScript 发展历史</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x67vz8.html">HTTP协议漫谈&lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj1l409.html">STURTS2 HELLOWORLD</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdxd4y9.html">JavaScript 基本类型值-Undefined、Null、Boolean</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj5eyx8.html">MySQLSyntaxErrorException&colon;  You have an error in your SQL syntax&semi;  check the manual that corresponds to your MySQL server version for the right syntax to use near &period;&period;&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1ky7m59.html">从Leetcode的Combination Sum系列谈起回溯法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjzpjx8.html">Spring Boot实战笔记（五）-- Spring高级话题（Spring Aware）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpnoxvq.html">【c&num;】RabbitMQ学习文档（三）Publish&sol;Subscribe（发布&sol;订阅）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd1lly9.html">20175205 2018-2019-2 《Java程序设计》第五周学习总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdw0d2j9.html">vs code 格式化vue代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2z3319.html">前端面试题整理&mdash;ajax篇</a>
		</li>
						<li><a href="https://www.batexi.com/a/qve5n619.html">PowerBI开发 第十二篇：钻取</a>
		</li>
						<li><a href="https://www.batexi.com/a/qve3l0x9.html">第一次spring冲刺第3、4天</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rnrx6rq.html">怎样application不被第三方应用杀掉--Android</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q1kzml09.html">HDU 4726 Kia&amp;&num;39&semi;s Calculation （贪心算法）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1kzzm29.html">SEO分享：我为什么会有这么多的优质外链资源？</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojkkwxq.html">算法-最长子序列和C&sol;C&plus;&plus;实现（三个复杂度）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgdnme8.html">用python将SQL格式文件改成自己想要的格式</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zm7ng9.html">EasyUI - Tooltip 提示控件</a>
			</li>
						<li><a href="https://www.batexi.com/a/qljmoke9.html">ASP&period;NET - TreeView</a>
			</li>
						<li><a href="https://www.batexi.com/a/qljmnm09.html">控件编写：增强 TMEMO （一）（增加对WM&lowbar;HSCROLL消息的处理）</a>
			</li>
						<li><a href="https://www.batexi.com/a/96po5jy8.html">JavaScript的原型继承</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnj1wdk8.html">Android菜鸟的成长笔记（6）&mdash;&mdash;剖析源码学自定义主题Theme</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnj1wg38.html">测试关闭mojo utf-8</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
